/* iarray.h */

/*
    Tucnak - VHF contest log
    Copyright (C) 2002-2006  Ladislav Vaiz <ok1zia@nagano.cz>
    and authors of glib www.gtk.org

*/


/* GLIB - Library of useful routines for C programming
 * Copyright (C) 1995-1997  Peter Mattis, Spencer Kimball and Josh MacDonald
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * Modified by the GLib Team and others 1997-1999.  See the AUTHORS
 * file for a list of people on the GLib Team.  See the ChangeLog
 * files for a list of changes.  These files are distributed with
 * GLib at ftp://ftp.gtk.org/pub/gtk/. 
 */

#ifndef _IARRAY_H
#define _IARRAY_H

typedef struct _GIndexArray GIndexArray;
struct _GIndexArray
{
  gpointer *pdata;
  guint     len;
};


void init_iarray(void);
void free_iarray(void);
#define     g_index_array_index(array,index) (array->pdata)[index]
GIndexArray* g_index_array_new (void);
void      g_index_array_free (GIndexArray *array, gboolean free_seg);
void      g_index_array_free_all(GIndexArray *array);
void      g_index_array_set_size (GIndexArray *array, gint length);
gpointer  g_index_array_remove_index (GIndexArray *array, guint index);
gpointer  g_index_array_remove_index_fast (GIndexArray *array, guint index);
gboolean  g_index_array_remove (GIndexArray *array, gpointer data);
gboolean  g_index_array_remove_fast (GIndexArray *array, gpointer data);
void      g_index_array_add (GIndexArray *array, gpointer data);


void g_index_array_qsort (GIndexArray *farray, int (*compar)(const void *, const void *));
gpointer *g_index_array_bsearch(GIndexArray *farray, const void *key, int (*compar)(const void *, const void *));
gint g_index_array_bsearch_index(GIndexArray *farray, const void *key, int (*compar)(const void *, const void *));


void g_ptr_array_free_all(GPtrArray *array);
void g_ptr_array_free_items(GPtrArray *array);
void g_ptr_array_qsort (GPtrArray *farray, int (*compar)(const void *, const void *));

#endif
